#!/usr/bin/env perl
use strict;
use AnyEvent;

sub read_stdin {
    my $cv = AnyEvent->condvar;
    AnyEvent::Util::fh_nonblocking(\*STDIN, 1);
    my $w; $w = AnyEvent->io(
        fh => \*STDIN,
        poll => 'r',
        cb => sub {
            undef $w;
            my $line = <STDIN>;
            $cv->send( $line );
        }
    );
    return $cv;
}

my $main_cv = AnyEvent->condvar;


{ # １個目。こちらはSTDERR にprint …(1)
    my $cv = read_stdin();
    $cv->cb( sub {
        my ($line) = $_[0]->recv;
        print STDERR "STDERR: got $line";
        $main_cv->send;
    } );
}

# １個目の読み込みが終わるまで待機・・・
$main_cv->recv;

$main_cv = AnyEvent->condvar;

{ # ２個目。こちらはSTDOUTにprint …(2)
    my $cv = read_stdin();
    $cv->cb( sub {
        my ($line) = $_[0]->recv;
        print STDOUT "STDOUT: got $line";
        $main_cv->send;
    } );
}

# ２個目の読み込みが終わるまで待機・・・
$main_cv->recv;


